(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: MENTOS.PAS                                                     *)
(*  Obsah: simulator magickeho souboje                                     *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*  Posledni uprava: 26.5.2014                                             *)
(*  Pro kompilaci: viz uses                                                *)
(*  Pro spusteni: LATIN2.CH, ale jde to i bez nej                          *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program magicky_souboj;
{$I-}
uses retezce,cas,texty2,textmenu,klavesy2;

var bhc:pole256znaku; {tabulka pro likvidaci diakritiky v zaklinadlech}
    PuvodniCharset,latin2:charset; {znakove sady - puvodni a nase}
    MameNovyCharset:boolean; {jestli jsme nastavovali nasi znakovou sadu}
    PuvodniRezim:byte; {puvodni rezim obrazovky v okamziku spusteni program}
    hm:byte; {cislo volby v hlavnim menu}

type zaklstring=string[13];
     velkepolestringu=array[0..14] of zaklstring;
     malepolestringu=array[0..4] of zaklstring;

const zaklinadla_utok_g:velkepolestringu=     {gawainska sada zaklinadel}
          ('VODA','MRZ','SMRT','LES','OHE',
           'LVA','KREV','K','OLEJ','MOST',
           'SL','SLUNCE','OREL','VTR','KOV');
      zaklinadla_obrana_g:malepolestringu=
          ('voda','mrz','smrt','les','ohe');

      zaklinadla_utok_a:velkepolestringu=     {awainska sada zaklinadel}
          ('OHE','MRZ','ELEKTINA','SMRT','JED',
           'MEDZA','FNIX','JEDNOROEC','DRAK','GRYF',
           'HMC VODA','ZC SLUNCE','ELEZN GOLEM','HLUBOK LES','SMEKA VLK');
      zaklinadla_obrana_a:malepolestringu=
          ('ohe','mrz','elektina','smrt','jed');

{Utocna zaklinadla maji kody 0..14, misto obrannych se predava kod volneho
seslani. Kody a jejich navaznosti jsou stejne pro gawainskou i awainskou sadu,
lisi se jenom jmena, ktera zobrazujeme.}
const ZacatekSouboje=15;
      VolneSeslani=16;
      Konec=100; {kod pro ukonceni souboje, aby se nemusela zavadet dalsi promenna}

var StylZacatku,StylZaklinadel:char; {'A' jako Awain nebo 'G' jako Gawain}
    Obtiznost:byte; {1 - je videt tabulka zaklinadel, seznamy zaklinadel
                         co kdo pouzil a seznam moznych zaklinadel pri kazdem
                         seslani
                     2 - jako 1, ale bez seznamu pouzitych zaklinadel
                     3 - 2 bez seznamu aktualnich moznosti
                     4 - 3 bez tabulky zaklinadel
                     5 - 4 bez jakychkoli doplnujicich informaci, plus vsechna
                         zaklinadla psana stejne velkym pismem
                     6 - 5 bez historie}
    CasovyLimit:boolean; {true => kdo nezareaguje do 20 vterin, prohral}
    InteligencePocitace:byte; {1 - zaklinadla sype vicemene nahodne a nikdy
                                   nepouzije rozhodujici
                               2 - jako 1, ale rozhodujici seslat muze
                               3 - kouzli cilevedome tak, aby prozkoumal
                                   vsechny souperovy reakce a nasel slabinu
                               4 - jako 3, ale navic blufuje s obranou}

const limitS=20; {casovy limit na seslani zaklinadla (normalne je 15 s, ale
                 psani je pomalejsi nez mluveni, tak radsi par vterin pridame)}
      limitMS=1000*limits; {totez v milisekundach}
      NazvyObtiznosti:array[1..6] of string[12]=('Pro blb',
                                                 'ajek',
                                                 'Bez npovdy',
                                                 'Po pamti',
                                                 'Pro mistry',
                                                 'Masakr');
      NazvyInteligence:array[1..4] of string[7]=('Dobrk',
                                                 'Chaotik',
                                                 'Logik',
                                                 'Dmon');

type moznosti=array[0..14] of boolean; {pro ukladani informaci o tom, ktere zaklinadlo se da seslat nebo bylo seslano}

var zaklinadla_utok:velkepolestringu;   {aktualne pouzivana sada zaklinadel}
    zaklinadla_obrana:malepolestringu;

{nejdulezitejsi vec - vlastni jadro hry:}
type hrac=object {instance jsou dve: jedna pro ziveho hrace, druha pro pocitac}
          Slabina:byte; {ktere elementarni zaklinadlo je moje slabina (0..4)}
          PouzilPriVolnem:moznosti; {proti opakovani zaklinadel pri volnem seslani}
          Odpovidal:array[0..4] of boolean; {cim uz jsem odpovidal na utoky}
          MojeMoznosti:moznosti; {co vsechno ted muzu seslat}
          ObrannaMoznost:byte; {kdyz seslu tohle, bude to obranna verze}
          BylBlafak:boolean; {jestli uz jsem se branil, i kdyz jsem mohl utocit (pouze pro pocitac)}
          prohral:boolean; {jestli jsem prohral}
          procedure init(RucniVyberSlabiny:boolean);
           {Volej pred kazdym soubojem. Parametr urcuje, jestli se ma slabina
           vybirat rucne (true) nebo nahodne (false).}
          procedure ZjistiMoznosti(Utok:byte; var Souper:hrac);
           {Vyplni pole MojeMoznosti podle daneho Utoku (to muze byt
           utocne zaklinadlo, volne seslani nebo zacatek souboje) a pripadne
           nastavi Souperovi prohru, pokud se nasla reakce na rozhodujici
           zaklinadlo.}
          function KouzliRucne(MinulyUtok:byte):byte;
           {Necha hrace seslat zaklinadlo reagujici na MinulyUtok (vyznam
           parametru jako u predchozi metody) a vraci kod tohoto zaklinadla
           (v pripade pasu nebo obrany vraci kod volneho seslani).}
          function KouzliAuto(MinulyUtok:byte; var Souper:hrac):byte;
           {Podobna, ale zaklinadlo vybira pocitac. Odkaz na Soupere vyuziva
           pro kontrolu dosud pouzitych zaklinadel.}
          end;

var clovek,pocitac:hrac;
    ZacinaPocitac:boolean;

procedure casomira; far;
{Zobrazi zbyvajici cas v pravem hornim rohu obrazovky. Vola se bud rucne
nebo casovacem na pozadi.}
var s:integer; {zbyvajici sekundy}
    b:byte; {barva}
Begin
if casovylimit then begin
                    s:=limits-getms div 1000;
                    if s>0 then begin
                                if s<=3 then b:=12
                                        else if s<=7 then b:=14
                                                     else b:=10;
                                writexy(70,1,b,nastr2(s,2))
                                end
                           else writexy(70,1,12,'vyprel!');
                    end
               else writexy(70,1,10,'neomezen');
End;{casomira}

procedure prekresli; {vykresli tabulky a ukazatele v horni polovine obrazovky}
var i,y,b:byte;
    radek:string;
Begin
for y:=1 to 14 do vymazradek(y,7);
writexy(1,1,11,'Obtnost:'); writexy(12,1,10,nazvyobtiznosti[obtiznost]);
writexy(30,1,11,'Soupe:'); writexy(38,1,10,nazvyinteligence[inteligencepocitace]);
writexy(55,1,11,'Zbvajc as:'); casomira;
if obtiznost<=3
  then begin {tabulka zaklinadel}
       writexy(1,2,9,'Rozhodujc:');
       writexy(16,2,9,'Elementrn:');
       writexy(49,2,9,'Druhotn:');
       y:=3;
       for i:=0 to 4 do begin
                        writexy(1,y,15,zaklinadla_utok[i+10]+':'); {rozhodujici}
                        if i=clovek.slabina then b:=12 else b:=15; {barva (slabina je cervena)}
                        writexy(16,y,b,zaklinadla_utok[i]+':'); {elementarni}
                        if (i+1) mod 5=clovek.slabina then b:=4 else b:=7;
                        writexy(27,y,b,zaklinadla_utok[(i+1) mod 5]+','); {reakce - utok}
                        writexy(72,y,b,zaklinadla_utok[(i+1) mod 5]); {prvni reakce na druhotne}
                        if (i+3) mod 5=clovek.slabina then b:=4 else b:=7;
                        writexy(38,y,b,zaklinadla_obrana[(i+3) mod 5]); {reakce - obrana}
                        writexy(49,y,15,zaklinadla_utok[i+5]+':'); {druhotne}
                        if i=clovek.slabina then b:=4 else b:=7;
                        writexy(61,y,b,zaklinadla_utok[i]+','); {druha reakce na druhotne}
                        inc(y);
                        end;
       end;
if obtiznost=1
  then begin {seznam pouzitych zaklinadel}
       writexy(1,8,9,'Zaklnadla dosud pouit jako reakce:');
       radek:='Ty: ';
       for i:=0 to 4 do if clovek.odpovidal[i] then radek:=radek+zaklinadla_utok[i]+' ';
       writexy(1,9,2,radek);
       radek:='Soupe: ';
       for i:=0 to 4 do if pocitac.odpovidal[i] then radek:=radek+zaklinadla_utok[i]+' ';
       writexy(1,10,2,radek);
       writexy(1,11,9,'Zaklnadla dosud pouit pi volnm sesln:');
       radek:='Ty: ';
       for i:=0 to 9 do if clovek.pouzilprivolnem[i] then radek:=radek+zaklinadla_utok[i]+' ';
       writexy(1,12,2,radek);
       radek:='Soupe: ';
       for i:=0 to 9 do if pocitac.pouzilprivolnem[i] then radek:=radek+zaklinadla_utok[i]+' ';
       writexy(1,13,2,radek);
       end;
writexy(1,14,14,zarovnej(' pro ukonen napi "konec" ',80,_nastred,'-'));
End;{prekresli}

procedure hrac.init(RucniVyberSlabiny:boolean);
var i:byte;
    m:tmenu;
Begin
if rucnivyberslabiny then begin
                          writexy(1,2,7,'Zvol si svou slabinu:');
                          with m do begin
                                    init(4);
                                    for i:=0 to 4 do polozka(zaklinadla_utok[i]);
                                    kontrola;
                                    slabina:=hodnota-1;
                                    end;
                          end
                     else slabina:=random(5);
fillchar(pouzilprivolnem,sizeof(moznosti),false);
fillchar(odpovidal,sizeof(odpovidal),false);
obrannamoznost:=100; {cokoli neplatneho}
bylblafak:=false;
prohral:=false;
End;{hrac.init}

procedure hrac.ZjistiMoznosti(utok:byte; var souper:hrac);
var i:byte;
Begin
if utok=zacateksouboje then begin
                            if stylzacatku='G' then begin {Gawain: cokoli krome slabiny}
                                                    for i:=0 to 9 do mojemoznosti[i]:=true;
                                                    mojemoznosti[slabina]:=false;
                                                    end
                                               else {Awain: jakekoli druhotne zaklinadlo}
                                                    for i:=5 to 9 do mojemoznosti[i]:=true;
                            for i:=10 to 14 do mojemoznosti[i]:=false; {rozhodujici na zacatku nejdou}
                            end
 else if utok=volneseslani then begin {cokoli krome tech, ktere uz jsem pouzil}
                                for i:=0 to 14 do mojemoznosti[i]:=not pouzilprivolnem[i];
                                obrannamoznost:=100;
                                end
  else begin {nucene seslani}
       for i:=0 to 14 do mojemoznosti[i]:=false;
       case utok of 0..4:begin {elementarni}
                         mojemoznosti[(utok+1) mod 5]:=true; {obrana i utok}
                         mojemoznosti[(utok+3) mod 5]:=true; {obrana}
                         obrannamoznost:=(utok+3) mod 5;
                         end;
                    5..9:begin {druhotne}
                         mojemoznosti[utok-5]:=true;
                         mojemoznosti[(utok-4) mod 5]:=true;
                         obrannamoznost:=100; {cokoli neplatneho - obe moznosti jsou utocne}
                         end;
                    10..14:mojemoznosti[utok-10]:=true; {rozhodujici}
                    end;
       mojemoznosti[slabina]:=false; {slabinou reagovat nemuzu}
       end;
prohral:=true;
for i:=0 to 14 do if mojemoznosti[i] then prohral:=false; {kdo nema cim reagovat, prohral}
if (utok>=10)and(utok<=14) and not prohral then souper.prohral:=true; {souper spatne urcil slabinu a tim prohral}
End;{hrac.zjistimoznosti}

function hrac.kouzlirucne(minulyutok:byte):byte;
var i:byte;
    zaklinadlo:string[20];
Begin
if obtiznost<=2 then begin
                     write('M na vbr z tchto zaklnadel: ');
                     for i:=0 to 14 do
                     if mojemoznosti[i] then begin
                                             if i=obrannamoznost then write(zaklinadla_obrana[i])
                                                                 else write(zaklinadla_utok[i]);
                                             write(', ');
                                             end;
                     if minulyutok=volneseslani then writeln('PAS.') {misto volneho muzu pasnout}
                                                else writeln(#8#8'.');
                     prekresli;
                     end;
 if casovylimit then startcekani;
 repeat
 obarviradek(wherey,10);
 write('Tvj tah: ');
 readln(zaklinadlo);
 obarviradek(wherey,7);
 zaklinadlo:=strip(zaklinadlo,'O',' '); {orez pripadne mezery}
 zaklinadlo:=prekodujretezec(zaklinadlo,bhc); {zlikviduj pripadnou diakritiku}
 zaklinadlo:=stringup(zaklinadlo); {preved na velka pismena}
 if zaklinadlo='KONEC' then begin
                            writeln('Dobr, konme.');
                            if casovylimit then stopcekani;
                            kouzlirucne:=konec;
                            exit;
                            end;
 i:=0;
  repeat {nalezeni zadaneho zaklinadla v tabulce}
  if zaklinadlo=prekodujretezec(zaklinadla_utok[i],bhc) then break;
  inc(i);
  until i>14;
 if i>14 then begin {zaklinadlo neni v tabulce}
              if (minulyutok=volneseslani)and(zaklinadlo='PAS')
                then begin {pas pri volnem seslani - v poradku}
                     i:=volneseslani;
                     break;
                     end
                else begin
                     writeln('Tohle nen platn zaklnadlo.');
                     prekresli;
                     if casovylimit and (getms>limitms) then break;
                     end;
              end
  else if mojemoznosti[i] then break {je v tabulce a muzu ho seslat - OK}
   else begin
        writeln('Zaklnadlo ',zaklinadla_utok[i],' te seslat neme.'); {je v tabulce, ale seslat ho ted nemuzu}
        prekresli;
        if casovylimit and (getms>limitms) then break;
        end;
 until false;
{mame platne zaklinadlo}
if casovylimit then begin
                    stopcekani;
                    if getms>limitms then begin
                                          prohral:=true;
                                          kouzlirucne:=konec;
                                          writeln('Trvalo ti to moc dlouho - prohrls.');
                                          prekresli;
                                          exit;
                                          end;
                    end;
if i=volneseslani
  then begin {pas}
       if obtiznost<=4 then writeln('Nedl nic, soupe zskv pleitost k volnmu sesln.');
       kouzlirucne:=i;
       end
  else begin {reakce nebo zacatek souboje}
       if i=obrannamoznost then begin
                                if obtiznost<=4 then writeln('Sesl obrann zaklnadlo ',zaklinadla_obrana[i],
                                                             ', soupe zskv pleitost k volnmu sesln.');
                                kouzlirucne:=volneseslani;
                                end
                           else begin
                                if obtiznost<=4 then writeln('Sesl ton zaklnadlo ',zaklinadla_utok[i],',',
                                                             ' soupe bude muset reagovat.');
                                kouzlirucne:=i;
                                end;
       if minulyutok=volneseslani then pouzilprivolnem[i]:=true
                                  else if i<=4 then odpovidal[i]:=true;
                                        {^i po zacatku souboje je tohle OK - slabina se pouzit neda, takze se muze vyloucit}
       end;
End;{hrac.kouzli_rucne}

function hrac.kouzliauto(minulyutok:byte; var souper:hrac):byte;
{}procedure zjm2(utok:byte; var reakce1,reakce2:byte); {zjisti dve mozne reakce na dane utocne zaklinadlo}
{}Begin
{}case utok of 0..4:begin {elementarni}
{}                  reakce1:=(utok+1) mod 5; {obrana i utok}
{}                  reakce2:=(utok+3) mod 5; {obrana}
{}                  end;
{}             5..9:begin {druhotne}
{}                  reakce1:=utok-5;         {obrana i utok}
{}                  reakce2:=(utok-4) mod 5; {obrana i utok}
{}                  end;
{}             end;
{}End;{zjm2}
var i:byte;
    pocet:byte;
    r1,r2:byte;
    vhodne:moznosti;
Begin
{Taktika podle stupne inteligence:
 * Demon *
zacatek: nahodne vybrane druhotne zaklinadlo
volne seslani: jestli si jsem jisty, dam rozhodujici a vyhraju
               jestli uz jsem vycerpal vsechna normalni zaklinadla, dam PAS
                (to by se teoreticky stat nemelo, vyhraju driv, ale radsi
                at je to osetrene)
               jinak dam neco, co ma jako obe odpovedi neco, na co souper
                jeste nereagoval (nemuze se stat, ze by takova moznost
                nebyla - to uz by musel reagovat ctyrikrat, ale to uz bych
                vyhral a sem bych vubec nedosel)
nucene seslani: jestli nemam na vyber, neni co resit, seslu to
                jinak se snazim odpovidat tim, cim uz jsem odpovidal driv,
                 abych se moc neodkryval
                jinak jednou s 50% pravdepodobnosti zablafuju obranou
                 a pak davam prednost utocne verzi
 * Logik *
totez, jenom neblafuje - vzdycky si vybira utocnou verzi, pokud to jde
 * Chaotik *
zacatek: nahodne vybrane zaklinadlo
volne seslani: jestli si jsem jisty, dam rozhodujici a vyhraju
               jestli uz jsem vycerpal vsechna normalni zaklinadla, dam PAS
               jinak neco nahodne vyberu
nucene seslani: jestli nemam na vyber, neni co resit, seslu to
                jinak nejakou odpoved vyberu nahodne
 * Dobrak *
totez, ale pri volnem sesilani nepouziva rozhodujici zaklinadla}
if minulyutok=zacateksouboje
  then begin
       if (inteligencepocitace<=2)and(stylzacatku='G')
         then begin {dobrak a chaotik}
              pocet:=random(9)+1; {10 minus slabina}
              for i:=0 to 9 do if mojemoznosti[i]
                 then begin
                      dec(pocet);
                      if pocet=0 then begin
                                      kouzliauto:=i;
                                      writeln(zaklinadla_utok[i],'.');
                                      if i<=4 then odpovidal[i]:=true;
                                      break;
                                      end;
                      end;
              end
         else begin
              {logik a demon zacnou nahodne vybranym druhotnym zaklinadlem:}
              i:=5+random(5);
              kouzliauto:=i;
              writeln(zaklinadla_utok[i],'.');
              end;
       end
 else if minulyutok=volneseslani
        then begin
             if inteligencepocitace>1
               then begin
                    {cim vsim uz souper odpovidal:}
                    pocet:=0;
                    for i:=0 to 4 do if souper.odpovidal[i] then inc(pocet);
                    {Jestli zbylo jenom jedno nepouzite, musi to byt slabina,
                    takze hodim prislusne rozhodujici zaklinadlo a je
                    vymalovano:}
                    if pocet=4 then for i:=0 to 4 do
                                     if not souper.odpovidal[i] then begin
                                                                     kouzliauto:=i+10;
                                                                     writeln(zaklinadla_utok[i+10],'.');
                                                                     exit;
                                                                     end;
                    {Jinak nema cenu riskovat, pokracuju normalnimi zaklinadly.}
                    end;
             {Jestli uz jsem vsechna vycerpal, musim vynechat tah:}
             pocet:=0;
             for i:=0 to 9 do if pouzilprivolnem[i] then inc(pocet);
             if pocet>9 then begin
                             kouzliauto:=volneseslani;
                             if obtiznost<=4 then write('Dola mi zaklnadla, uij si voln sesln. ');
                             writeln('PAS.');
                             exit;
                             end;
             {jinak mam na vyber, tak neco vyberu:}
             if inteligencepocitace<=2
               then begin {dobrak a chaotik}
                    pocet:=0; {spocitam moznosti}
                    for i:=0 to 9 do if mojemoznosti[i] then inc(pocet);
                    pocet:=random(pocet)+1; {jednu nahodne vyberu}
                    for i:=0 to 9 do if mojemoznosti[i] then begin
                                                             dec(pocet);
                                                             if pocet=0 then begin
                                                                             kouzliauto:=i;
                                                                             writeln(zaklinadla_utok[i],'.');
                                                                             pouzilprivolnem[i]:=true;
                                                                             break;
                                                                             end;
                                                             end;
                    end
               else begin {logik a demon}
                    {Zkusim vybrat neco, co ma jako obe odpovedi to,
                    na co souper jeste neodpovidal:}
                    fillchar(vhodne,sizeof(moznosti),false);
                    pocet:=0;
                    for i:=0 to 9 do
                     if not pouzilprivolnem[i]
                       then begin
                            zjm2(i,r1,r2); {cim by na tohle mohl souper reagovat}
                            if not(souper.odpovidal[r1] or souper.odpovidal[r2])
                              then begin {jeste nereagoval ani jednim}
                                   vhodne[i]:=true;
                                   inc(pocet);
                                   end;
                            end;
                    {Jestli souper zatim reagoval 1..3 ruznymi zaklinadly,
                    budu ted mit minimalne jednu moznost. Jestli uz reagoval
                    ctyrmi, odchytilo se to vyse (seslal jsem rozhodujici
                    zaklinadlo) a sem uz se nedostanu.
                    Takze z dostupnych moznosti jednu nahodne vyberu a konec:}
                    pocet:=random(pocet)+1;
                    for i:=0 to 9 do if vhodne[i] then begin
                                                       dec(pocet);
                                                       if pocet=0 then begin
                                                                       kouzliauto:=i;
                                                                       writeln(zaklinadla_utok[i],'.');
                                                                       break;
                                                                       end;
                                                       end;
                    end; {vyber podle inteligence}
             end {volne seslani}
  else begin {nucene seslani (odpovida se jedine elementarnimi zaklinadly)}
       pocet:=0;
       for i:=0 to 4 do if mojemoznosti[i] then begin
                                                inc(pocet);
                                                r1:=i; {aby se to za chvili nemuselo zase hledat}
                                                end;
       if pocet=1 then begin {kdyz nemam na vyber, neni co resit}
                       odpovidal[r1]:=true;
                       if r1=obrannamoznost then begin
                                                 if obtiznost<=4 then writeln(zaklinadla_obrana[r1],'. M voln sesln.')
                                                                 else writeln(zaklinadla_utok[r1],'.'); {uplne bez napovedy}
                                                 kouzliauto:=volneseslani;
                                                 end
                                            else begin
                                                 writeln(zaklinadla_utok[r1],'.');
                                                 kouzliauto:=r1;
                                                 end;
                       exit;
                       end;
       {Mam dve moznosti (nula to byt nemuze, to uz bych prohral a sem bych
       se vubec nedostal), takze zase zalezi na inteligenci:}
       if inteligencepocitace<=2
         then begin {dobrak nebo chaotik}
              pocet:=random(2)+1; {jednu moznost nahodne vyberu}
              for i:=0 to 4 do if mojemoznosti[i]
                 then begin
                      dec(pocet);
                      if pocet=0 then begin
                                      odpovidal[i]:=true;
                                      if i=obrannamoznost then begin
                                                               if obtiznost<=4 then writeln(zaklinadla_obrana[i],
                                                                                            '. M voln sesln.')
                                                                               else writeln(zaklinadla_utok[i],'.');
                                                               kouzliauto:=volneseslani;
                                                               end
                                                          else begin
                                                               writeln(zaklinadla_utok[i],'.');
                                                               kouzliauto:=i;
                                                               end;
                                      break;
                                      end;
                      end;
              end
         else begin {logik nebo demon}
              {Zkusim odpovedet tim, cim uz jsem odpovidal drive:}
              for i:=0 to 4 do
               if mojemoznosti[i] and odpovidal[i]
                 then begin
                      if i=obrannamoznost then begin
                                               if obtiznost<=4 then writeln(zaklinadla_obrana[i],'. M voln sesln.')
                                                               else writeln(zaklinadla_utok[i],'.');
                                               kouzliauto:=volneseslani;
                                               end
                                          else begin
                                               writeln(zaklinadla_utok[i],'.');
                                               kouzliauto:=i;
                                               end;
                      exit;
                      end;
              {Neodpovidal jsem zatim ani jednou moznosti.}
              if minulyutok<=4
                then begin {elementarni zaklinadlo - jedna moznost utok, druha obrana}
                     {Jestli je jedna moznost obranna, demon zkusi zablafovat:}
                     if (inteligencepocitace=4) and not bylblafak and (random(2)=0) and mojemoznosti[(minulyutok+3) mod 5]
                       then begin
                            if obtiznost<=4 then writeln(zaklinadla_obrana[(minulyutok+3) mod 5],'. M voln sesln.')
                                            else writeln(zaklinadla_utok[(minulyutok+3) mod 5],'.');
                            kouzliauto:=volneseslani;
                            odpovidal[(minulyutok+3) mod 5]:=true;
                            bylblafak:=true;
                            exit;
                            end;
                     {jinak dam prednost utocne verzi (logik vzdy):}
                     if mojemoznosti[(minulyutok+1) mod 5] then i:=(minulyutok+1) mod 5 {utok}
                                                           else i:=(minulyutok+3) mod 5; {obrana}
                     if i=obrannamoznost then if obtiznost<=4 then writeln(zaklinadla_obrana[i],'. M voln sesln.')
                                                              else writeln(zaklinadla_utok[i],'.')
                                         else writeln(zaklinadla_utok[i],'.');
                     odpovidal[i]:=true;
                     kouzliauto:=i;
                     end
                else begin {druhotne zaklinadlo - obe moznosti jsou utocne a je jedno, kterou vyberu}
                     pocet:=random(pocet)+1; {byla tam dvojka}
                     for i:=0 to 4 do if mojemoznosti[i] then begin
                                                              dec(pocet);
                                                              if pocet=0 then begin
                                                                              kouzliauto:=i;
                                                                              writeln(zaklinadla_utok[i],'.');
                                                                              odpovidal[i]:=true;
                                                                              break;
                                                                              end;
                                                              end;
                     end;
              end; {vyber podle inteligence}
       end; {nucene seslani}
End;{hrac.kouzli_auto}

function NastavObtiznost(puvodni:byte):byte; {rucni vyber obtiznosti}
var m:tmenu;
Begin
cls(7);
writexy(20,4,15,'Nastaven obtnosti');
with m do begin
          init(6);
          polozka(nazvyobtiznosti[1]);
          popis('Nejjednodu varianta s nejvtm mnostvm npovd. Je vidt tabulka');
          popis('zaklnadel, seznamy zaklnadel, kter kdy kdo pouil, a seznam monch');
          popis('zaklnadel pi kadm sesln.');
          polozka(nazvyobtiznosti[2]);
          popis('M k dispozici tabulku zaklnadel a npovdu, co zrovna me pout.');
          popis('Co kdo kdy zakouzlil si u mus pamatovat sm.');
          polozka(nazvyobtiznosti[3]);
          popis('Dostane jenom tabulku zaklnadel, bez npovdy pi sesln.');
          polozka(nazvyobtiznosti[4]);
          popis('U neuvid ani tabulku, zaklnadla a jejich vztahy si mus pamatovat.');
          popis('Jedin ulehen budou obasn poznmky jako "te m voln sesln"');
          popis('a podobn.');
          polozka(nazvyobtiznosti[5]);
          popis('Te u je to skoro jako naivo: vechna soupeova zaklnadla jsou psna');
          popis('stejn velkm psmem, take je na tob, abys poznal, kdy m voln sesln');
          popis('a kdy ne. dnou npovdu u nedostane.');
          polozka(nazvyobtiznosti[6]);
          popis('Kompletn bez npovd a navc bez historie - vid jenom jedno aktuln');
          popis('soupeovo zaklnadlo a nic vc. Jako ve skutenosti.');
          hodnota:=puvodni;
          kontrola;
          nastavobtiznost:=hodnota;
          end;
End;{nastavobtiznost}

function NastavInteligenci(puvodni:byte):byte; {rucni vyber inteligence pocitace}
var m:tmenu;
Begin
cls(7);
writexy(20,4,15,'Nastaven inteligence soupee');
with m do begin
          init(6);
          polozka(nazvyinteligence[1]);
          popis('Soupe nepeml a zaklnadla sesl naprosto nhodn (v rmci pravidel).');
          popis('Navc nikdy nepouije rozhodujc zaklnadlo, take prohrt me jedin');
          popis('vlastn chybou.');
          popis('Vhodn pro zatenky na trnink a zapamatovn zvislosti zaklnadel.');
          polozka(nazvyinteligence[2]);
          popis('Soupe sice pod kouzl metodou nhodnho vbru, ale pokud si vlastn');
          popis('neopatrnost odkryje celou svou obranu a pust ho k volnmu sesln,');
          popis('dostane t rozhodujcm zaklnadlem.');
          popis('Vhodn pro zatenky, kte chtj aspo trochu frovou hru.');
          polozka(nazvyinteligence[3]);
          popis('Soupe kouzl clevdom tak, aby co nejdv odkryl celou tvou obranu a');
          popis('zrove aby se sm moc neodkrval. M ale slab msto: obrannou variantu');
          popis('zaklnadla vol jedin v ppad, e ton je jeho slabinou. Tm se sm');
          popis('okamit prozrad.');
          popis('Vhodn pro ncvik strategie a pamatovn kdo u co seslal.');
          polozka(nazvyinteligence[4]);
          popis('Tenhle soupe u vykazuje jist stupe vypotavosti: pokud sele obrannou');
          popis('variantu zaklnadla, me to bt jenom bluf a slabina me bt pln jinde.');
          popis('Jinak je stejn chytr jako '+nazvyinteligence[3]+'.');
          popis('Tm rovnocenn protivnk pro ivho mga.');
          hodnota:=puvodni;
          kontrola;
          nastavinteligenci:=hodnota;
          end;
End;{nastavinteligenci}

function HlavniMenu(puvodni:byte):byte;
var m:tmenu;
Begin
cls(7);
writexy(20,3,14,'*** Trenar magickho souboje ***');
writexy(20,4,4,'Pravidla (c) Yuh 1997 a Necron 2013');
writexy(19,5,4,'Programovn (c) Murphy/Mircosoft 2013');
writexy(26,6,4,'http://mircosoft.mzf.cz');
with m do begin
          init(8);
          if stylzaklinadel='G' then begin
                                     polozka('Styl zaklnadel: Gawain');
                                     popis('Hraje se s Yuhovou sadou zaklnadel: voda, mrz, smrt, les, ohe atd.');
                                     end
                                else begin
                                     polozka('Styl zaklnadel: Awain');
                                     popis('Hraje se s Necronovou sadou zaklnadel: ohe, mrz, elektina, smrt, jed');
                                     popis('atd.');
                                     end;
          if stylzacatku='G' then begin
                                  polozka('Pravidla zahjen: Gawain');
                                  popis('Souboj sm zahjit jakmkoli druhotnm nebo elementrnm zaklnadlem');
                                  popis('krom sv slabiny. V praxi se ale stejn vtinou zahajuje druhotnm, aby');
                                  popis('se zbyten neodkrvala obrana.');
                                  end
                             else begin
                                  polozka('Pravidla zahjen: Awain');
                                  popis('Souboj sm zahjit jakmkoli druhotnm zaklnadlem.');
                                  end;
          polozka('Nastaven obtnosti');
          popis('Vyber si, jak moc ti m pota napovdat a co vechno si m pamatovat');
          popis('za tebe.');
          polozka('Vbr soupee');
          popis('Vyber si, jak chytrho protivnka chce mt: od naprostho nekuby');
          popis('po vychytralho taktika.');
          if casovylimit then begin
                              polozka('asov limit pro sesln zaklnadla: ano');
                              popis('To znamen, e jestli nezareaguje do '+nastr(limits)+' vtein, automaticky');
                              popis('prohrv.');
                              end
                         else begin
                              polozka('asov limit pro sesln zaklnadla: ne');
                              popis('as t netla, take si v klidu studuj tabulky, vymlej strategii atd.');
                              end;
          polozka('MENTOS!');
          popis('Pipraven? Tak tmhle zahj souboj.');
          polozka('Npovda');
          popis('Strun pravidla a jin vysvtlivky.');
          polozka('Konec');
          popis('A t to pestane bavit, tmhle program vypne.');
          hodnota:=puvodni;
          kontrola;
          if zruseno then hlavnimenu:=8
                     else hlavnimenu:=hodnota;
          end;
End;{hlavnimenu}

procedure boj; {stara se o hlavni cyklus hry a volani funkci jadra}
var zaklinadlo:byte; {posledne seslane zaklinadlo}
    zac:char; {pro klavesnici - vyber, kdo zacina}
Begin
if stylzaklinadel='G' then begin
                           zaklinadla_utok:=zaklinadla_utok_g;
                           zaklinadla_obrana:=zaklinadla_obrana_g;
                           end
                      else begin
                           zaklinadla_utok:=zaklinadla_utok_a;
                           zaklinadla_obrana:=zaklinadla_obrana_a;
                           end;
cls(7);
clovek.init(true);
pocitac.init(false);
cls(7);
gotoxy(3,3);
write('Chce zat? (A/N) ');
tkurzorzap; {kurzor zustane zapnuty az do konce souboje}
readln(zac);
zacinapocitac:=upcase(zac)<>'A';
gotoxy(1,15);
zaklinadlo:=zacateksouboje;
if casovylimit then nastavprocedurunapozadi(@casomira,1000);
 repeat
 prekresli;
 if zacinapocitac then begin
                       startcekani; pockej(400);
                       if obtiznost=6 then begin {smazani historie}
                                           cls(7); prekresli; gotoxy(1,15);
                                           end;
                       obarviradek(wherey,12);
                       write('Soupev tah: ');
                       startcekani; pockej(1100);
                       pocitac.zjistimoznosti(zaklinadlo,clovek);
                       if pocitac.prohral then begin
                                               writeln('Nemm m reagovat. Blahopeji k vtzstv.');
                                               break;
                                               end;
                       zaklinadlo:=pocitac.kouzliauto(zaklinadlo,clovek);
                       if clovek.prohral then begin
                                              writeln('patn, moje slabina je ',zaklinadla_utok[pocitac.slabina],
                                                      '. Prohrls.');
                                              break;
                                              end;
                       obarviradek(wherey,7); {pristi informacni radek bude sedy}
                       end;
 prekresli;
 clovek.zjistimoznosti(zaklinadlo,pocitac);
 if clovek.prohral then begin
                        writeln('Nem m reagovat, prohrls.');
                        break;
                        end;
 {pocitac ted prohrat nemuze, protoze nikdy nezkazi rozhodujici zaklinadlo,
 takze to ani nemusime kontrolovat}
 zaklinadlo:=clovek.kouzlirucne(zaklinadlo);
 zacinapocitac:=true; {aby se v dalsich iteracich pocitac nevynechaval}
 until zaklinadlo=konec;
if casovylimit then zrusprocedurunapozadi;
tkurzorvyp; {v nabidkach je kurzor vypnuty}
prekresli;
writexy(11,25,14,'Stiskni libovolnou klvesu, tm se vrt do hlavn nabdky.');
zac:=readkey;
End;{boj}

procedure napoveda;
var stranka:byte;
    o:word;
Begin
stranka:=1;
 repeat
 cls(7); gotoxy(20,1);
 obarviradek(1,10);
 obarviradek(25,14);
 writeln('Pravidla magickho souboje  (',stranka,'/4)');
 writeln;
 case stranka of 1:begin
 writeln(' Soupei na sebe navzjem seslaj speciln zaklnadla. Ta se dl do t');
 writeln('skupin po pti: elementrn, druhotn a rozhodujc. Na kad elementrn');
 writeln('nebo druhotn zaklnadlo existuj vdy prv dv mon elementrn');
 writeln('zaklnadla, ktermi se d odpovdt; takov odpovdi se k nucen sesln.');
 writeln('Jedna z odpovd na elementrn zaklnadla je tzv. obrann - na ni nen');
 writeln('poteba reagovat a nsleduje tzv. voln sesln. Pi nm se me seslat');
 writeln('jakkoli zaklnadlo (elementrn, druhotn i rozhodujc), jedin podmnka');
 writeln('je, e se pi kadm volnm sesln mus pout jin. Kdo u vechny monosti');
 writeln('vyerpal, mus ct PAS a prvo volnho sesln tm pejde na soupee.');
 writeln;
 writeln(' Na kad rozhodujc zaklnadlo se d odpovdt prv jednm elementrnm.');
 writeln;
 writeln(' Kad ze soupe m tzv. slabinu. Jde o jedno elementrn zaklnadlo, kter');
 writeln('si ped soubojem zvol a kter potom neme pouvat jako reakci pi nucenm');
 writeln('sesln. Clem magickho souboje je protivnkovu slabinu odhalit a pi');
 writeln('pleitosti volnho sesln seslat rozhodujc zaklnadlo, na kter soupe');
 writeln('nebude moci odpovdt a tm prohraje. Ovem pokud nkdo ur soupeovu');
 writeln('slabinu patn a na jeho rozhodujc zaklnadlo je odpovzeno, prohrv.');
                   end;
                 2:begin
 writeln(' Seznam zaklnadel a monch reakc je uveden v tabulce, kter se zobrazuje');
 writeln('bhem hry na prvn ti rovn obtnosti. Zaklnadla jsou bl, reakce ed,');
 writeln('k rozhodujcm zaklnadlm pat elementrn zaklnadla hned vedle. Malmi');
 writeln('psmeny jsou vypsny obrann verze zaklnadel. erven je zvraznna tvoje');
 writeln('slabina, slabinu protivnka pochopiteln nevid.');
 writeln;
 writeln(' Zaklnadla je poteba vypisovat cel, ale nezle na velikosti psmen ani');
 writeln('na diakritice. Kdy se hraje naivo, obvykle se pouv asov limit 15');
 writeln('vtein - kdo nem co ct, prohrl. Tady je limit del, protoe psan je');
 writeln('pomalej ne mluven. Ppadn si ho me pln vypnout.');
 writeln;
 writeln(' Magick souboj je pedevm trnink pamti. Je poteba pamatovat si spoustu');
 writeln('vc: zaklnadla a jejich nvaznost, co u jsem pouil pi volnm sesln');
 writeln('(aby se to neopakovalo), co pouil soupe pi nucenm sesln (a co tedy');
 writeln('nen jeho slabina) a co jsem pouil j (a snait se pouvat pokud mono');
 writeln('pod to sam, abych soupei moc nenapovdal). Pota m pam؜ dokonalou,');
 writeln('proto se proti nmu hraje dost tاko. Ale porazit se d.');
                   end;
                 3:begin
 writeln(' Pi he naivo se souboj zahajuje heslem MENTOS. Na to druh strana odpov');
 writeln('bu rovnا MENTOS (vzvu pijm), nebo EBY? (neum kouzlit a souboje se');
 writeln('tedy neme zastnit), nebo se rovnou vzd.');
 writeln;
 writeln(' Bhem souboje jsou astnci nezraniteln a nevnmaj okoln svt. Jedin');
 writeln('vliv na dal prbh hry vyplv z postihu poraenho: obvykle jde o ubrn');
 writeln('poloviny ivot nebo pravdiv zodpovzen njak otzky, ale me se hrt');
 writeln('i o jin vci.');
                   end;
                 4:begin
 writeln(' Jet pr technickch pipomnek k programu:');
 writeln;
 writeln(' V nabdkch se pohybuje ipkami, Enterem se vybraj jednotliv monosti.');
 writeln('Nkdy jde o jednoduch pepna, jindy se oteve dal nabdka. Dole pod');
 writeln('nabdkou se zobrazuje npovda k aktuln vybran poloce. Esc vrac na');
 writeln('pedchoz nabdku nebo ukonuje program.');
 writeln;
 writeln(' Soubor LATIN2.CH zajiuje sprvn zobrazen esk diakritiky. Kdy ho');
 writeln('smae, program pobا s vchoz znakovou sadou a me se stt, e msto');
 writeln('hk a rek uvid rozsypan aj.');
 writeln;
 writeln(' Nastaven se neukld, pi dalm sputn programu si mus vechno');
 writeln('nastavit znovu.');
 writeln;
 writeln(' V ppad jakchkoli problm mi napi na adresu mircosoft@centrum.cz,');
 writeln('zkusm to opravit.');
 writeln;
 writeln;
 writeln(' Magii zdar!');
                   end;
                 end;
 gotoxy(10,25);
 write('Pgup - pedchoz strnka, Pgdn - dal strnka, Esc - zpt');
 o:=xreadkey;
 case o of xpgup:if stranka>1 then dec(stranka);
           xpgdn:if stranka<4 then inc(stranka);
           end;
 until o=xesc;
End;{napoveda}

BEGIN
{Program je staveny na textovy rezim 80x25. Zhruba od Windows XP dal uz se
ale neda spolehat na to, ze bude automaticky nastaveny, tak si ho radsi
zkontrolujeme a pripadne nastavime sami:}
asm
mov AH,15    {sluzba "zjisti, v jakem rezimu jsme"}
int $10
mov puvodnirezim,AL  {takze tohle tu ted mame}
cmp AL,3             {je to rezim c. 3 (nas pozadovany 80x25)?}
je @vporadku         {jestli jo, neni co resit...}
 xor AH,AH
 mov AL,3
 int $10              {...jinak se do nej prepneme}
@vporadku:
end;
{Potom je potreba zajistit, aby se na obrazovce spravne zobrazily ceske hacky
a carky. Jediny zarucene spolehlivy zpusob je pouzit svoji vlastni znakovou
sadu:}
loadcharsetfromvga(puvodnicharset); {ulozime puvodni znakovou sadu}
loadcharsetfromdisk(latin2,'LATIN2.CH'); {ze souboru nacteme nasi}
if ioresult=0 then begin {jestli se nacteni povedlo...}
                   applycharset(latin2); {...posleme nasi sadu graficke karte}
                   mamenovycharset:=true;
                   end
              else mamenovycharset:=false;
randomize; {inicializace generatoru nahodnych cisel}
PripravPrevodniTabulku(klatin2,kbezdiakritiky,bhc); {odhackovavaci tabulka}
stylzacatku:='G';
stylzaklinadel:='G';
obtiznost:=1;                               {nejake vychozi nastaveni}
inteligencepocitace:=1;
casovylimit:=false;
hm:=6;
tkurzorvyp; {ve vsech nabidkach a napovedach je kurzor vypnuty}
 Repeat
 hm:=hlavnimenu(hm);
 case hm of 1:if stylzaklinadel='G' then stylzaklinadel:='A'
                                    else stylzaklinadel:='G';
            2:if stylzacatku='G' then stylzacatku:='A'
                                 else stylzacatku:='G';
            3:obtiznost:=nastavobtiznost(obtiznost);
            4:inteligencepocitace:=nastavinteligenci(inteligencepocitace);
            5:casovylimit:=not casovylimit;
            6:boj;
            7:napoveda;
            end;
 Until hm>=8;
{hotovo, jeste po sobe uklidime:}
cls(7); gotoxy(1,1); tkurzorzap;
if mamenovycharset then applycharset(puvodnicharset); {obnovime puvodni znakovou sadu}
asm {vratime obrazovku do puvodniho stavu}
mov AL,puvodnirezim
cmp AL,3
je @vporadku
 xor AH,AH
 int $10
@vporadku:
end;
END.
{
0 VODA: 1 MRAZ, 3 les
1 MRAZ: 2 SMRT, 4 ohen
2 SMRT: 3 LES,  0 voda
3 LES:  4 OHEN, 1 mraz
4 OHEN: 0 VODA, 2 smrt

5 LAVA: 0 VODA, 1 MRAZ
6 KREV: 1 MRAZ, 2 SMRT
7 KUN:  2 SMRT, 3 LES
8 OLEJ: 3 LES,  4 OHEN
9 MOST: 4 OHEN, 0 VODA

10 SUL:    0 VODA
11 SLUNCE: 1 MRAZ
12 OREL:   2 SMRT
13 VITR:   3 LES
14 KOV:    4 OHEN

Zacina se cimkoli krome rozhodujicich a slabiny.
Pri nucenem seslani nejde slabina.
Pri volnem jde cokoli (vcetne slabiny), ale nesmi se to opakovat.
Pri volnem se da rict PAS, pak dostane volne seslani souper.
Rozhodujici zaklinadla jdou jenom pri volnem.

                                   sul

                         most               lava

                                  voda
                  kov                             slunce
                            ohen         mraz


                     olej      les    smrt      krev


                        vitr      kun        orel
}